const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const semen_analyses = sequelize.define(
    'semen_analyses',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

test_date: {
        type: DataTypes.DATE,
      
      

      },

volume_ml: {
        type: DataTypes.DECIMAL,
      
      

      },

concentration_million_per_ml: {
        type: DataTypes.DECIMAL,
      
      

      },

motility_percent: {
        type: DataTypes.DECIMAL,
      
      

      },

morphology_percent: {
        type: DataTypes.DECIMAL,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  semen_analyses.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


















































































































//end loop



    db.semen_analyses.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });




    db.semen_analyses.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.semen_analyses.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return semen_analyses;
};


